#!/usr/bin/env python
"""
adds licenses to python packages
"""

import os
import sys
from optparse import OptionParser
from pkg_resources import iter_entry_points

def license_list(debug=False):
    licenses = {}
    for entry_point in iter_entry_points('licenser.license'):
        try:
            license = entry_point.load()
        except Exception, e:
            if debug:
                import pdb; pdb.set_trace()
            else:
                print >> sys.stderr, "Couldn't load license '%s' [%s]" % (entry_point.name, e)
                continue
        licenses[entry_point.name] = license
    return licenses


def main(args=sys.argv[1:]):
    usage = '%prog [options] directory'
    parser = OptionParser(usage, description=__doc__)
    parser.add_option('-d', '--debug', action='store_true', default=False,
                      help="debug the application")
    parser.add_option('-l', '--license',
                      help="license to use")
    parser.add_option('--list', action='store_true', default=False,
                      help="list available licenses")
    options, args = parser.parse_args(args)

    licenses = license_list()

    if options.list: # list the licenses
        for i in sorted(licenses.keys()):
            doc = getattr(licenses[i], '__doc__')
            if doc:
                print '%s: %s' % (i, doc)
            else:
                print i
        sys.exit(0)

    if not options.license:
        parser.error("Must specify --license")

    for directory in args:
        filelist = files(directory)

if __name__ == '__main__':
    main()
